/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 18 dec. 2007 11:55:09

import java.util.Enumeration;

import org.cocktail.carambole.server.MyComponent;
import org.cocktail.fwkcktldepense.server.exception.FactoryException;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EOExercice;
import org.cocktail.fwkcktldepense.server.process.ProcessCommande;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WODisplayGroup;
import com.webobjects.eocontrol.EOAndQualifier;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.eocontrol.EOOrQualifier;
import com.webobjects.eocontrol.EOQualifier;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSKeyValueCoding;
import com.webobjects.foundation.NSMutableArray;

import er.extensions.eof.ERXEC;
import er.extensions.eof.ERXQ;

public class CommandeChoixDuplicationPourBasculeEnMasse extends MyComponent {

	private static final long serialVersionUID = 1L;

	public CommandeChoixDuplicationPourBasculeEnMasse(WOContext context) {
		super(context);
	}

	@SuppressWarnings("unchecked")
	private WOComponent basculer(boolean withCreationEngagements, boolean withInfosBudgetaires) {
		WOComponent nextPage = pageWithName("CommandeListe");
		WODisplayGroup dg = dgCommande();
		NSArray<NSDictionary<String, ?>> resultats = null;

		try {
			EOEditingContext edc = ERXEC.newEditingContext();
			EOExercice exercice = (EOExercice) dg.queryBindings().objectForKey("exercice");
			if (exercice != null) {
				EOQualifier qualExercice = EOQualifier.qualifierWithQualifierFormat(EOCommande.EXERCICE_KEY + "=%@", new NSArray<EOExercice>(exercice));
				NSMutableArray<EOQualifier> qualifiers = new NSMutableArray<EOQualifier>();
				// Transformation du tableau de dico en tableau de commandes
				NSArray<EOCommande> commandes = null;
				NSArray<NSDictionary<String, Object>> dicosCommande = dg.selectedObjects();
				if (dicosCommande.count() == 0) {
					throw new FactoryException("Aucune commande selectionnee. Impossible de basculer les commandes", true);
				}

				Enumeration<NSDictionary<String, Object>> enumDicosCommande = dicosCommande.objectEnumerator();
				while (enumDicosCommande.hasMoreElements()) {
					NSDictionary<String, Object> unDicoCommande = enumDicosCommande.nextElement();
					//EOQualifier qual = EOQualifier.qualifierWithQualifierFormat(EOCommande.COMM_NUMERO_KEY + "=%@", new NSArray(unDicoCommande.objectForKey("NUMERO")));
					EOQualifier qual = ERXQ.equals(EOCommande.COMM_NUMERO_KEY, unDicoCommande.objectForKey("NUMERO"));
					qualifiers.addObject(qual);
				}
				EOOrQualifier qualNumCmde = new EOOrQualifier(qualifiers);
				EOQualifier qualCommandes = new EOAndQualifier(new NSArray<EOQualifier>(new EOQualifier[] {
						qualExercice, qualNumCmde
				}));

				commandes = session.dataBus().fetchArray(edc, EOCommande.ENTITY_NAME, qualCommandes, null);
				resultats = ProcessCommande.basculer(session.dataBus(), edc, commandes, exerciceDuJour(), utilisateurInContext(edc), withInfosBudgetaires, withCreationEngagements);
				session.setAlertMessage(null);

				nextPage = (CommandeListeResultatsApresTraitementEnMasse) pageWithName("CommandeListeResultatsApresTraitementEnMasse");
				EOQualifier qualResultatsOK = EOQualifier.qualifierWithQualifierFormat("erreur = %@", new NSArray<Object>(NSKeyValueCoding.NullValue));
				EOQualifier qualResultatsKO = EOQualifier.qualifierWithQualifierFormat("erreur != %@", new NSArray<Object>(NSKeyValueCoding.NullValue));
				((CommandeListeResultatsApresTraitementEnMasse) nextPage).setResultatsOK(EOQualifier.filteredArrayWithQualifier(resultats, qualResultatsOK));
				((CommandeListeResultatsApresTraitementEnMasse) nextPage).setResultatsKO(EOQualifier.filteredArrayWithQualifier(resultats, qualResultatsKO));
			}
			else {
				throw new FactoryException("Exercice = null dans les bindings: Impossible de basculer les commandes", true);
			}
		} catch (FactoryException e) {
			String alertMessage = e.getMessageFormatte();
			if (e.isBloquant()) {
				if (e.isInformatif()) {
					// Exception contenant un message d'information pour l'utilisateur
					((CommandeListe) nextPage).setDg(dg);
					((CommandeListe) nextPage).setLesCommandes(dg.allObjects());
					((CommandeListe) nextPage).setLesCommandesSelectionnees(dg.selectedObjects());
					session.setAlertMessage(alertMessage);
				}
				else {
					e.printStackTrace();
					throw e;
				}
			}
			else {
				nextPage = (CommandeListeResultatsApresTraitementEnMasse) pageWithName("CommandeListeResultatsApresTraitementEnMasse");
				EOQualifier qualResultatsOK = EOQualifier.qualifierWithQualifierFormat("erreur = %@", new NSArray<Object>(NSKeyValueCoding.NullValue));
				EOQualifier qualResultatsKO = EOQualifier.qualifierWithQualifierFormat("erreur != %@", new NSArray<Object>(NSKeyValueCoding.NullValue));
				((CommandeListeResultatsApresTraitementEnMasse) nextPage).setResultatsOK(EOQualifier.filteredArrayWithQualifier(resultats, qualResultatsOK));
				((CommandeListeResultatsApresTraitementEnMasse) nextPage).setResultatsKO(EOQualifier.filteredArrayWithQualifier(resultats, qualResultatsKO));
				session.setAlertMessage(alertMessage);
			}
		} catch (RuntimeException e1) {
			session.setAlertMessage(e1.getMessage());
			e1.printStackTrace();
			throw e1;
		}

		return nextPage;
	}

	public WOComponent basculer() {
		return basculer(true, true);
	}

	public WOComponent basculerPartiellementAvecInfosBudgetaires() {
		return basculer(false, true);
	}

	public WOComponent basculerPartiellementSansInfosBudgetaires() {
		return basculer(false, false);
	}

	@SuppressWarnings("unchecked")
	public WOComponent annuler() {
		CommandeListe nextPage = (CommandeListe) pageWithName("CommandeListe");
		WODisplayGroup dg = dgCommande();
		nextPage.setDg(dg);
		nextPage.setLesCommandes(dg.allObjects());
		nextPage.setLesCommandesSelectionnees(dg.selectedObjects());
		return nextPage;
	}
}